searchNodes=[{"doc":"A task for interactively running tests","ref":"Mix.Tasks.Test.Interactive.html","title":"Mix.Tasks.Test.Interactive","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Test.Interactive.html#run/1","title":"Mix.Tasks.Test.Interactive.run/1","type":"function"},{"doc":"Interactively run your Elixir project's tests.","ref":"MixTestInteractive.html","title":"MixTestInteractive","type":"module"},{"doc":"Start the interactive test runner.","ref":"MixTestInteractive.html#run/1","title":"MixTestInteractive.run/1","type":"function"},{"doc":"Behaviour for interactive mode commands. All commands must implement this behaviour. It is recommended to use this module in the command's module: defmodule MyCommand do use MixTestInteractive.Command , command : &quot;c&quot; , desc : &quot;do the thing&quot; # ... end This will provide overridable implementations of most of the callbacks. :command is the key sequence the user will use to invoke the command. If a more appropriate command name is required in the help text, you can override the name/0 callback. :desc is the command's description. :command and :desc should be written so that the following pattern reads nicely in the usage output: &lt;command&gt; to &lt;description&gt; . For example, a to run all tests .","ref":"MixTestInteractive.Command.html","title":"MixTestInteractive.Command","type":"behaviour"},{"doc":"Is the command applicable given the current configuration? Returns true by default if not overridden.","ref":"MixTestInteractive.Command.html#c:applies?/1","title":"MixTestInteractive.Command.applies?/1","type":"callback"},{"doc":"The command's key sequence. Key sequences should be short (single character preferred) and unique. Returns the value of the :command argument passed in the use statement. Not overridable.","ref":"MixTestInteractive.Command.html#c:command/0","title":"MixTestInteractive.Command.command/0","type":"callback"},{"doc":"The command's description. Descriptions should be written to fit the pattern &lt;command&gt; to &lt;description&gt; . For example, a to run all tests . Returns the value of the :desc argument passed in the use statement. Not overridable.","ref":"MixTestInteractive.Command.html#c:description/0","title":"MixTestInteractive.Command.description/0","type":"callback"},{"doc":"The command's name. Readable name for the command. Defaults to the command/0 , but can be overridden to make usage output clearer.","ref":"MixTestInteractive.Command.html#c:name/0","title":"MixTestInteractive.Command.name/0","type":"callback"},{"doc":"Execute the command. Performs the desired action in response to the command. Most commands return an :ok tuple with an updated configuration, allowing MixTestInteractive.InteractiveMode to run the tests with the new configuration. A command can return a :no_run tuple with an updated configuration if the tests should not be run in response to the command. A command can return :help to show detailed usage information, or :quit to exit mix test.interactive . No default provided.","ref":"MixTestInteractive.Command.html#c:run/2","title":"MixTestInteractive.Command.run/2","type":"callback"},{"doc":"","ref":"MixTestInteractive.Command.html#t:response/0","title":"MixTestInteractive.Command.response/0","type":"type"},{"doc":"Processes interactive mode commands.","ref":"MixTestInteractive.CommandProcessor.html","title":"MixTestInteractive.CommandProcessor","type":"module"},{"doc":"Processes a single interactive mode command.","ref":"MixTestInteractive.CommandProcessor.html#call/2","title":"MixTestInteractive.CommandProcessor.call/2","type":"function"},{"doc":"Returns an ANSI-formatted usage summary. Includes only commands that are applicable to the current configuration.","ref":"MixTestInteractive.CommandProcessor.html#usage/1","title":"MixTestInteractive.CommandProcessor.usage/1","type":"function"},{"doc":"","ref":"MixTestInteractive.CommandProcessor.html#t:response/0","title":"MixTestInteractive.CommandProcessor.response/0","type":"type"},{"doc":"Configuration for the task.","ref":"MixTestInteractive.Config.html","title":"MixTestInteractive.Config","type":"module"},{"doc":"Create a new config struct, taking values from the application environment.","ref":"MixTestInteractive.Config.html#new/0","title":"MixTestInteractive.Config.new/0","type":"function"},{"doc":"","ref":"MixTestInteractive.Config.html#t:t/0","title":"MixTestInteractive.Config.t/0","type":"type"},{"doc":"Server for interactive mode. Processes commands from the user and requests to run tests due to file changes. This ensures that commands cannot be processed while tests are already running. Any commands that come in while the tests are running will be processed once the test run has completed.","ref":"MixTestInteractive.InteractiveMode.html","title":"MixTestInteractive.InteractiveMode","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"MixTestInteractive.InteractiveMode.html#child_spec/1","title":"MixTestInteractive.InteractiveMode.child_spec/1","type":"function"},{"doc":"Process command-line arguments.","ref":"MixTestInteractive.InteractiveMode.html#command_line_arguments/2","title":"MixTestInteractive.InteractiveMode.command_line_arguments/2","type":"function"},{"doc":"Tell InteractiveMode that one or more files have changed.","ref":"MixTestInteractive.InteractiveMode.html#note_file_changed/1","title":"MixTestInteractive.InteractiveMode.note_file_changed/1","type":"function"},{"doc":"Process a command from the user.","ref":"MixTestInteractive.InteractiveMode.html#process_command/2","title":"MixTestInteractive.InteractiveMode.process_command/2","type":"function"},{"doc":"Start the interactive mode server.","ref":"MixTestInteractive.InteractiveMode.html#start_link/1","title":"MixTestInteractive.InteractiveMode.start_link/1","type":"function"},{"doc":"","ref":"MixTestInteractive.InteractiveMode.html#t:option/0","title":"MixTestInteractive.InteractiveMode.option/0","type":"type"},{"doc":"Run the tasks in a new OS process via Port s. On Unix-like operating systems, it runs the tests using a zombie_killer script as describe in https://hexdocs.pm/elixir/Port.html#module-zombie-operating-system-processes . It also enable ANSI output mode. On Windows, mix is run directly and ANSI mode is not enabled, as it is not always supported by Windows command processors.","ref":"MixTestInteractive.PortRunner.html","title":"MixTestInteractive.PortRunner","type":"module"},{"doc":"Run tests based on the current configuration.","ref":"MixTestInteractive.PortRunner.html#run/4","title":"MixTestInteractive.PortRunner.run/4","type":"function"},{"doc":"","ref":"MixTestInteractive.PortRunner.html#t:os_type/0","title":"MixTestInteractive.PortRunner.os_type/0","type":"type"},{"doc":"","ref":"MixTestInteractive.PortRunner.html#t:runner/0","title":"MixTestInteractive.PortRunner.runner/0","type":"type"},{"doc":"Runs tests based on current configuration. Also responsible for optionally clearing the terminal and printing the current time.","ref":"MixTestInteractive.Runner.html","title":"MixTestInteractive.Runner","type":"module"},{"doc":"Run tests using configured runner.","ref":"MixTestInteractive.Runner.html#run/2","title":"MixTestInteractive.Runner.run/2","type":"function"},{"doc":"Interactive mode settings. Keeps track of the current settings of MixTestInteractive.InteractiveMode , making changes in response to user commands.","ref":"MixTestInteractive.Settings.html","title":"MixTestInteractive.Settings","type":"module"},{"doc":"Update settings to run all tests, removing any flags or filter patterns.","ref":"MixTestInteractive.Settings.html#all_tests/1","title":"MixTestInteractive.Settings.all_tests/1","type":"function"},{"doc":"Assemble command-line arguments to pass to mix test . Includes arguments originally passed to mix test.interactive when it was started as well as arguments based on the current interactive mode settings.","ref":"MixTestInteractive.Settings.html#cli_args/1","title":"MixTestInteractive.Settings.cli_args/1","type":"function"},{"doc":"Create a new state struct, taking values from the command line. In addition to its own options, new/1 initializes its interactive mode settings from some of mix test 's options ( --failed , --stale , and any filename arguments).","ref":"MixTestInteractive.Settings.html#new/1","title":"MixTestInteractive.Settings.new/1","type":"function"},{"doc":"Update settings to only run failing tests. Corresponds to mix test --failed .","ref":"MixTestInteractive.Settings.html#only_failed/1","title":"MixTestInteractive.Settings.only_failed/1","type":"function"},{"doc":"Provide a list of file-name filter patterns. Only test filenames matching one or more patterns will be run.","ref":"MixTestInteractive.Settings.html#only_patterns/2","title":"MixTestInteractive.Settings.only_patterns/2","type":"function"},{"doc":"Update settings to only run &quot;stale&quot; tests. Corresponds to mix test --stale .","ref":"MixTestInteractive.Settings.html#only_stale/1","title":"MixTestInteractive.Settings.only_stale/1","type":"function"},{"doc":"Return a text summary of the current interactive mode settings.","ref":"MixTestInteractive.Settings.html#summary/1","title":"MixTestInteractive.Settings.summary/1","type":"function"},{"doc":"Toggle file-watching mode on or off.","ref":"MixTestInteractive.Settings.html#toggle_watch_mode/1","title":"MixTestInteractive.Settings.toggle_watch_mode/1","type":"function"},{"doc":"","ref":"MixTestInteractive.Settings.html#t:t/0","title":"MixTestInteractive.Settings.t/0","type":"type"},{"doc":"A server that runs tests whenever source files change.","ref":"MixTestInteractive.Watcher.html","title":"MixTestInteractive.Watcher","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"MixTestInteractive.Watcher.html#child_spec/1","title":"MixTestInteractive.Watcher.child_spec/1","type":"function"},{"doc":"Start the file watcher.","ref":"MixTestInteractive.Watcher.html#start_link/1","title":"MixTestInteractive.Watcher.start_link/1","type":"function"},{"doc":"Run all tests, removing any flags or filters.","ref":"MixTestInteractive.Command.AllTests.html","title":"MixTestInteractive.Command.AllTests","type":"module"},{"doc":"Run only failed tests. Equivalent to mix test --failed .","ref":"MixTestInteractive.Command.Failed.html","title":"MixTestInteractive.Command.Failed","type":"module"},{"doc":"Show detailed usage information. Lists all commands applicable to the current context.","ref":"MixTestInteractive.Command.Help.html","title":"MixTestInteractive.Command.Help","type":"module"},{"doc":"Specify one or more filename-matching patterns. Runs all tests that contain at least one of the patterns as a substring of their filename. If any pattern looks like a filename/line number pattern, then all of the patterns are passed on to mix test directly; no filtering is done. This is because mix test only supports a single filename-with-line-number pattern at a time.","ref":"MixTestInteractive.Command.Pattern.html","title":"MixTestInteractive.Command.Pattern","type":"module"},{"doc":"Exit mix test.interactive.","ref":"MixTestInteractive.Command.Quit.html","title":"MixTestInteractive.Command.Quit","type":"module"},{"doc":"Run all tests matching the current flags and filter settings.","ref":"MixTestInteractive.Command.RunTests.html","title":"MixTestInteractive.Command.RunTests","type":"module"},{"doc":"Run only stale tests. Equivalent to mix test --stale .","ref":"MixTestInteractive.Command.Stale.html","title":"MixTestInteractive.Command.Stale","type":"module"},{"doc":"Toggle file-watching mode on or off. When watch mode is on, mix test.interactive will re-run the current set of tests whenever a file changes. When it is off, tests must be run manually, either by changing using a command to change the configuration, or by using the MixTestInteractive.Command.RunTests command.","ref":"MixTestInteractive.Command.ToggleWatchMode.html","title":"MixTestInteractive.Command.ToggleWatchMode","type":"module"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"Changed Now tested against Elixir 1.12 and 1.13. ( #55 ) Misc. dependency upgrades. ( #55 ) Documentation Include proper source ref in the generated documentation so that it now points at the correct version of the source code. ( #51 - Thanks @kianmeng!) Include license and changelog in generated documentation. ( #51 - Thanks @kianmeng!)","ref":"changelog.html#v1-2-0","title":"Changelog - v1.2.0","type":"extras"},{"doc":"Fixed The p (pattern) command now works properly in umbrella projects. Previously, it was unable to find any test files in order to filter the pattern and would therefore not run any tests. Now, in an umbrella project, mix test.interactive looks for test files in apps/*/test by default, but still respects the :test_paths config option used by mix test . ( #48 ) Documentation Fixed the spelling of Louis Pilfold's name in the README. Sorry, Louis! 🤦‍♂️ ( #49 )","ref":"changelog.html#v1-1-0","title":"Changelog - v1.1.0","type":"extras"},{"doc":"Fixed Eliminates a GenServer call timeout that can occur if a command is typed while a long-running test run is in progress. ( #44 ).","ref":"changelog.html#v1-0-1","title":"Changelog - v1.0.1","type":"extras"},{"doc":"🎉 Happy Birthday! The following sections describe changes from mix-test.watch , which served as the basis of this project. Added Interactive mode allows dynamically filtering test files based on a substring pattern or switching to run only failed or stale tests without having to restart. File-watching mode can be turned on and off, either by passing --no-watch on the command line, or by using the w command to dynamically toggle watch mode on and off. When file-watching mode is on, tests will be run in response to file changes as with mix-test.watch . When off, tests must be run explicitly using the Enter key or by using another command that changes the set of tests to be run. Removed It is no longer possible to customize the CLI executable. We always use mix . Previously, this allowed the use of iex -S mix instead, but that doesn't work well with interactive mode. It is no longer possible to specify multiple tasks to run on file changes. This ability added complexity and the feature didn't work very well because it assumed that all tasks would take the exact same set of command-line arguments. It is still possible to specify a different task name than test , but mix test.interactive assumes that the custom task accepts the same command-line arguments as mix test . Fixed On Windows, mix test.interactive runs the correct mix task, including a custom task provided in the configuration, rather than always running mix test . It also passes along other provided command-line arguments as well as those injected by mix test.interactive .","ref":"changelog.html#v1-0-0","title":"Changelog - v1.0.0","type":"extras"},{"doc":"Copyright (c) 2021 Randy Coulman Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"mix test.interactive is an interactive test runner for ExUnit tests. Based on Louis Pilfold's wonderful mix-test.watch and inspired by Jest's interactive watch mode, mix test.interactive allows you to dynamically change which tests should be run with a few keystrokes. It allows you to easily switch between running all tests, stale tests, or failed tests. Or, you can run only the tests whose filenames contain a substring. Includes an optional &quot;watch mode&quot; which runs tests after every file change.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"The package can be installed by adding mix_test_interactive to your list of dependencies in mix.exs : def deps do [ { :mix_test_interactive , &quot;~&gt; 1.0&quot; , only : :dev , runtime : false } ] end","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"Run the mix task: mix test.interactive Your tests will run immediately (and every time a file changes). If you don't want tests to run automatically when files change, you can start mix test.interactive with the --no-watch flag: mix test.interactive --no-watch After the tests run, you can use the interactive mode to change which tests will run. Use the p command to run only test files that match one or more provided patterns. A pattern is the project-root-relative path to a test file (with or without a line number specification) or a string that matches a portion of full pathname. e.g. test/my_project/my_test.exs , test/my_project/my_test.exs:12:24 or my . If any pattern contains a line number specification, all patterns are passed directly to mix test . p pattern1 pattern 2 Use the s command to run only test files that reference modules that have changed since the last run (equivalent to the --stale option of mix test ). Use the f command to run only tests that failed on the last run (equivalent to the --failed option of mix test ). Use the a command to run all tests. Use the w command to turn file-watching mode on or off. Use the Enter key to re-run the current set of tests without requiring a file change. Use the q command, or press Ctrl-D to exit the program.","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"By default, mix test.interactive runs mix test . Through the mix config it is possible to run a different mix task. mix test.interactive assumes that this alternative task accepts the same command-line arguments as mix test . # config/config.exs use Mix.Config if Mix . env == :dev do config :mix_test_interactive , task : &quot;custom_test_task&quot; end The task is run with MIX_ENV set to test .","ref":"readme.html#running-a-different-mix-task","title":"Overview - Running A Different Mix Task","type":"extras"},{"doc":"Any command line arguments passed to the mix test.interactive task will be passed through to the task being run, along with any arguments added by interactive mode. If I want to see detailed trace information for my tests, I can run: mix test . interactive -- trace mix test.interactive will detect the --stale and --failed flags and use those as initial settings in interactive mode. You can then toggle those flags on and off as needed. It will also detect any filename or pattern arguments and use those as initial settings. However, it does not detect any filenames passed with --include or --only . Note that if you specify a pattern on the command-line, mix test.interactive will find all test files matching that pattern and pass those to mix test as if you had used the p command.","ref":"readme.html#passing-arguments-to-tasks","title":"Overview - Passing Arguments To Tasks","type":"extras"},{"doc":"If you want mix test.interactive to clear the console before each run, you can enable this option in your config/dev.exs as follows: # config/config.exs use Mix.Config if Mix . env == :dev do config :mix_test_interactive , clear : true end","ref":"readme.html#clearing-the-console-before-each-run","title":"Overview - Clearing The Console Before Each Run","type":"extras"},{"doc":"To ignore changes from specific files or directories add exclude: regexp patterns to your config in mix.exs : # config/config.exs use Mix.Config if Mix . env == :dev do config :mix_test_interactive , exclude : [ ~r/db_migration \\/ .*/ , ~r/useless_.* \\. exs/ ] end The default is exclude: [~r/\\.#/, ~r{priv/repo/migrations}] .","ref":"readme.html#excluding-files-or-directories","title":"Overview - Excluding files or directories","type":"extras"},{"doc":"On Linux you may need to install inotify-tools .","ref":"readme.html#compatibility-notes","title":"Overview - Compatibility Notes","type":"extras"},{"doc":"You can enable desktop notifications with ex_unit_notifier .","ref":"readme.html#desktop-notifications","title":"Overview - Desktop Notifications","type":"extras"},{"doc":"This project started as a clone of the wonderful mix-test.watch project, which I've used and loved for years. I've added the interactive mode features to the existing feature set. The idea for having an interactive mode comes from Jest and its incredibly useful interactive watch mode.","ref":"readme.html#acknowledgements","title":"Overview - Acknowledgements","type":"extras"},{"doc":"Copyright (c) 2021-2022 Randy Coulman This work is free. You can redistribute it and/or modify it under the terms of the MIT License. See the LICENSE.md file for more details.","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]